// Sprocket Framework header file
// File.h



#pragma once

#ifndef __ALIASES__
#include <Aliases.h>
#endif

#ifndef __SCRIPT__
#include <Script.h>
#endif


class	TFile {
public:
						TFile();
						TFile(const FSSpec &inFileSpec);
						TFile(AliasHandle inAlias, Boolean &outWasChanged, FSSpec *inFromFile = nil);
	virtual				~TFile();
				
			void		GetSpecifier(FSSpec &outFileSpec) const;
	virtual void		SetSpecifier(FSSpec &inFileSpec);
	virtual AliasHandle	MakeAlias(FSSpec *inFromFile = nil);
					
	virtual OSErr		CreateNewFile(OSType inCreator, OSType inFileType,
										ScriptCode inScriptCode = smSystemScript);
	virtual OSErr		CreateNewDataFile(OSType inCreator, OSType inFileType,
										ScriptCode inScriptCode = smSystemScript);

	virtual short		OpenDataFork(short inPrivileges);
	virtual Handle		ReadDataFork();
	virtual long		WriteDataFork(const void *inBuffer, long inByteCount);
	virtual OSErr		CloseDataFork();
			short		GetDataForkRefNum() const;
					
	virtual short		OpenResourceFork(short inPrivileges);
	virtual OSStatus	CloseResourceFork();
			short		GetResourceForkRefNum() const;
			
	virtual	OSErr		Delete(void);
	//virtual OSErr		Save(void) = 0;
				
protected:
	FSSpec			fFileSpec;
	short			fDataForkRefNum;
	short			fResourceForkRefNum;
};
