// Sprocket Framework header file
// LinkedList.h



#ifndef		_LINKEDLIST_
#define		_LINKEDLIST_


const OSErr kLink_BadLinkErr = -1;
const OSErr kLinkedList_LinkNotFoundErr = -2;
const OSErr kLinkedList_CouldNotDeleteLinkErr = -3;




class	TLink
{
public:
							TLink( void *objectPtr );
	virtual 				~TLink();
	virtual void			SetPrevLink( TLink *prevLinkPtr )	{ fPrevLinkPtr = prevLinkPtr; }
	virtual void			SetNextLink( TLink *nextLinkPtr )	{ fNextLinkPtr = nextLinkPtr; }
	virtual TLink*			GetPrevLink(void)					{ return fPrevLinkPtr; }
	virtual TLink*			GetNextLink(void)					{ return fNextLinkPtr; }
	virtual void*			GetObjectPtr(void)					{ return fObjectPtr; }

protected:

  	TLink*					fPrevLinkPtr;
  	TLink*					fNextLinkPtr;
  	void*					fObjectPtr;
};


class	TLinkedList
{
public:
							TLinkedList();
	virtual 				~TLinkedList();

	virtual	OSErr			CreateAndAddLink( void *objectPtr );
	virtual	OSErr			FindAndDeleteLink( void *objectPtr );
	virtual unsigned long	CountLinks(void);
	virtual void			*GetNthLinkObject( unsigned long linkIndex );

protected:

	virtual void			DeleteAllLinks(void);
	TLink*					FindLink( void *objectPtr );
	virtual OSErr			DeleteLink( TLink *linkPtr );
	
	TLink*					fFirstLinkPtr;
	TLink*					fLastLinkPtr;
};

#endif
