// Sprocket Framework header file
// UResources.h



#ifndef __URESOURCES__
#define __URESOURCES__

#ifndef __RESOURCES__
#include <Resources.h>
#endif


typedef short	ResFileRefNum;
typedef short	ResID;
typedef short	ResAttributes;
typedef short	ResFileAttributes;
typedef UInt32	ResFilePermissions;


// These can't be supported under the System 7 resource manager (without ugly hacks anyway):
// --------------------------------------------------------------------------------
//	extern OSStatus RMRemoveResFileFromSearchPath(ResFileRefNum refNum);
//	extern OSStatus RMAddResFileToSearchPath(ResFileRefNum refNum);

// These can't be supported without some emulation of the FSObject-based file system:
// ----------------------------------------------------------------------------------
//	extern OSStatus RMCreateResFile(FSObjectRef fsFolderObjectRef, FSName fsName, OSType creator, OSType theType);
//	extern OSStatus RMOpenResFile(FSObjectRef specification, ResFilePermissions permissions, Boolean resLoad, ResFileRefNum *refNum);


#ifdef __cplusplus
extern "C" {
#endif

// These two functions are NOT part of the MacOS 8 Resource Manager

extern OSStatus RMCloseResFileCompat(ResFileRefNum refNum);
extern OSStatus RMUpdateResFileCompat(ResFileRefNum refNum);
extern OSStatus RMUseResFileCompat(ResFileRefNum refNum);
extern OSStatus RMCurResFileCompat(ResFileRefNum *refNum);
extern OSStatus RMHomeResFileCompat(Handle theResource, ResFileRefNum *refNum);

extern OSStatus RMAddResourceCompat(Handle theData, ResType theType, ResID theID, ConstStr255Param name);
extern OSStatus RMRemoveResourceCompat(Handle theResource);
extern OSStatus RMCountTypesCompat(Boolean oneDeep, UInt32 *count);
extern OSStatus RMGetIndexedTypeCompat(UInt32 index, Boolean oneDeep, ResType *theType);
extern OSStatus RMCountResourcesCompat(ResType theType, Boolean oneDeep, UInt32 *count);
extern OSStatus RMGetIndexedResourceCompat(ResType theType, UInt32 index, Boolean oneDeep, Boolean resLoad, Handle *handle);
extern OSStatus RMGetResourceCompat(ResType theType, ResID theID, Boolean oneDeep, Boolean resLoad, Handle *handle);
extern OSStatus RMGetNamedResourceCompat(ResType theType, ConstStr255Param name, Boolean oneDeep, Boolean resLoad, Handle *handle);
extern OSStatus RMLoadResourceCompat(Handle theResource);
extern OSStatus RMReleaseResourceCompat(Handle theResource);
extern OSStatus RMDetachResourceCompat(Handle theResource);
extern OSStatus RMChangedResourceCompat(Handle theResource);
extern OSStatus RMWriteResourceCompat(Handle theResource);
extern OSStatus RMSetResourceSizeCompat(Handle theResource, SInt32 newSize);

extern OSStatus RMUniqueIDCompat(ResType theType, Boolean oneDeep, ResID *idPtr);

extern OSStatus RMGetResAttributesCompat(Handle theResource, ResAttributes *attributes);
extern OSStatus RMSetResAttributesCompat(Handle theResource, ResAttributes attrs);

extern OSStatus RMGetResInfoCompat(Handle theResource, ResType *typePtr, ResID *idPtr, Str255 name);
extern OSStatus RMSetResInfoCompat(Handle theResource, ResType theType, ResID theID, ConstStr255Param name);

extern OSStatus RMReadPartialResourceCompat(Handle theResource, UInt32 offset, void *buffer, UInt32 count);
extern OSStatus RMWritePartialResourceCompat(Handle theResource, UInt32 offset, const void *buffer, UInt32 count);

extern OSStatus RMGetResourceSizeCompat(Handle theResource, SInt32 *size);
extern OSStatus RMSetResErrProcCompat(ResErrUPP proc);

extern OSStatus RMSetResFileReadOnlyStateCompat(ResFileRefNum refNum, Boolean isReadOnly);
extern OSStatus RMGetResFileReadOnlyStateCompat(ResFileRefNum refNum, Boolean *isReadOnly);



#ifdef __cplusplus
}
#endif

#if (BUILDING_FOR_SYSTEM8)

// We are compiling only for MacOS 8 or later, so use the real MacOS 8 RM API

#define RMCloseResFileCompat				RMCloseResFile
#define RMUpdateResFileCompat				RMUpdateResFile
#define RMUseResFileCompat					RMUseResFile
#define RMCurResFileCompat					RMCurResFile
#define RMHomeResFileCompat					RMHomeResFile
#define RMAddResourceCompat					RMAddResource
#define RMRemoveResourceCompat				RMRemoveResource
#define RMCountTypesCompat					RMCountTypes
#define RMGetIndexedTypeCompat				RMGetIndexedType
#define RMCountResourcesCompat				RMCountResources
#define RMGetIndexedResourceCompat			RMGetIndexedResource
#define RMGetResourceCompat					RMGetResource
#define RMGetNamedResourceCompat			RMGetNamedResource
#define RMLoadResourceCompat				RMLoadResource
#define RMReleaseResourceCompat				RMReleaseResource
#define RMDetachResourceCompat				RMDetachResource
#define RMChangedResourceCompat				RMChangedResource
#define RMWriteResourceCompat				RMWriteResource
#define RMSetResourceSizeCompat				RMSetResourceSize
#define RMUniqueIDCompat					RMUniqueID
#define RMGetResAttributesCompat			RMGetResAttributes
#define RMUpdateResFileCompat				RMUpdateResFile
#define RMGetResInfoCompat					RMGetResInfo
#define RMSetResInfoCompat					RMSetResInfo
#define RMSetResAttributesCompat			RMSetResAttributes
#define RMReadPartialResourceCompat			RMReadPartialResource
#define RMWritePartialResourceCompat		RMWritePartialResource
#define RMGetResourceSizeCompat				RMGetResourceSize
#define RMSetResErrProcCompat				RMSetResErrProc
#define RMSetResFileReadOnlyStateCompat		RMSetResFileReadOnlyState
#define RMGetResFileReadOnlyStateCompat		RMGetResFileReadOnlyState
#define RMFSpCreateResFileCompat			RMFSpCreateResFile
#define RMFSpOpenResFileCompat				RMFSpOpenResFile
	
#endif // (BUILDING_FOR_SYSTEM8)

#endif // __URESOURCES__

